﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace WebChatApi.Common
{
    /// <summary>
    /// Enum CompressionType
    /// Value struct in bit: [x][x][y]
    /// [x]: For object format: Json, Xml, Original object, etc.
    /// [y]: For indicating whether it is compressed
    /// </summary>
    [DataContract]
    public enum CompressionType
    {
        /// <summary>
        /// The none
        /// </summary>
        [EnumMember]
        None = 0,
        /// <summary>
        /// The compressed
        /// </summary>
        [EnumMember]
        Compressed = 1,
        /// <summary>
        /// The XML
        /// </summary>
        [EnumMember]
        Xml = 2,
        /// <summary>
        /// The json
        /// </summary>
        [EnumMember]
        Json = 4,
        /// <summary>
        /// The object
        /// </summary>
        [EnumMember]
        Object = 6
    }
}
