﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace WebChatApi.Common.Interface
{
    /// <summary>
    /// Interface for auditbale objects.
    /// </summary>
    public interface IAuditable
    {
        /// <summary>
        /// Gets the key.
        /// </summary>
        /// <value>
        /// The key.
        /// </value>
        Guid Key { get; }

        /// <summary>
        /// Gets the name of the source.
        /// </summary>
        /// <value>
        /// The name of the source.
        /// </value>
        string SourceName { get; }

        /// <summary>
        /// Gets the source identity.
        /// </summary>
        /// <value>
        /// The source identity.
        /// </value>
        string SourceIdentity { get; }

        /// <summary>
        /// Gets the data XML.
        /// </summary>
        /// <value>
        /// The data XML.
        /// </value>
        XElement DataXml { get; }

        /// <summary>
        /// Gets the created stamp.
        /// </summary>
        /// <value>
        /// The created stamp.
        /// </value>
        DateTime CreatedStamp { get; }
    }
}
