﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace WebChatApi.Common.Interface
{
    /// <summary>
    /// Interface IKeyBasedPagingCriteria
    /// </summary>
    public interface IKeyBasedPagingCriteria
    {
        /// <summary>
        /// Gets or sets the last retrieved key.
        /// </summary>
        /// <value>The last retrieved key.</value>
        Guid? LastRetrievedKey
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the count.
        /// </summary>
        /// <value>The count.</value>
        int Count
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the user key.
        /// </summary>
        /// <value>The user key.</value>
        Guid? UserKey
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets a value indicating whether [order description].
        /// </summary>
        /// <value><c>true</c> if [order description]; otherwise, <c>false</c>.</value>
        bool OrderDesc
        {
            get;
            set;
        }
    }
}
