﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WebChatApi.Common;

namespace WebChatApi.Common.Interface
{
    /// <summary>
    /// Interface for service response.
    /// </summary>
    public interface IServiceResponse
    {
        /// <summary>
        /// Gets or sets a value indicating whether this instance is success.
        /// </summary>
        /// <value>
        /// <c>true</c> if this instance is success; otherwise, <c>false</c>.
        /// </value>
        bool IsSuccess { get; set; }

        /// <summary>
        /// Gets or sets the exception info.
        /// </summary>
        /// <value>
        /// The exception info.
        /// </value>
        ExceptionInfo ExceptionInfo { get; set; }
    }
}
