﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using System.Xml.Serialization;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common.Audit
{
    /// <summary>
    /// Class for Audit Query Criteria
    /// </summary>
    [DataContract]
    [KnownType(typeof(BaseCriteria))]
    public class AuditQueryCriteria : BaseCriteria
    {
        #region Properties

        /// <summary>
        /// Gets or sets the name of the source.
        /// </summary>
        /// <value>
        /// The name of the source.
        /// </value>
        [DataMember]
        public string SourceName
        {
            get;
            set;
        }


        /// <summary>
        /// Gets or sets the source identity.
        /// </summary>
        /// <value>
        /// The source identity.
        /// </value>
        [DataMember]
        public string SourceIdentity
        {
            get;
            set;
        }


        /// <summary>
        /// Gets or sets from changeset id.
        /// </summary>
        /// <value>
        /// From changeset id.
        /// </value>
        [DataMember]
        public long FromChangesetId
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets to changeset id.
        /// </summary>
        /// <value>
        /// To changeset id.
        /// </value>
        [DataMember]
        public long ToChangesetId
        {
            get;
            set;
        }

        #endregion

        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="AuditQueryCriteria"/> class.
        /// </summary>
        public AuditQueryCriteria()
            : base()
        {
        }

        #endregion
    }
}
