﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using Gbi.Service.Interface;

namespace Gbi.Service.Common.Contracts.Model
{
    /// <summary>
    /// A model class for saving session information
    /// </summary>
    [DataContract]
    [KnownType(typeof(PermissionLevel))]
    public class InterfacePermission : BaseObject, IIdentifiable
    {
        #region Properties

        /// <summary>
        /// Gets or sets the permission.
        /// </summary>
        /// <value>
        /// The permission.
        /// </value>
        [DataMember]
        public PermissionLevel Permission
        {
            get;
            set;
        }

        #endregion

        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="InterfacePermission"/> class.
        /// </summary>
        public InterfacePermission()
            : base()
        {
        }

        #endregion
    }
}
