﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common
{
    /// <summary>
    /// </summary>
    [DataContract]
    [KnownType(typeof(UserInfo))]
    
    public class ThirdPartyUserInfo : UserInfo, IIdentifiable
    {
        #region Properties

        /// <summary>
        /// Gets or sets the third party ID.
        /// </summary>
        /// <value>
        /// The third party ID.
        /// </value>
        [DataMember]
        public string ThirdPartyID
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the third party source identity.
        /// <example>
        /// "sina", "tencent", etc.
        /// </example>
        /// </summary>
        /// <value>
        /// The third party source identity.
        /// </value>
        [DataMember]
        public string ThirdPartySourceIdentity
        {
            get;
            set;
        }

        #endregion

        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="ThirdPartyUserInfo"/> class.
        /// </summary>
        public ThirdPartyUserInfo()
            : base()
        {
        }

        #endregion
    }
}
