﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common
{
    /// <summary>
    /// </summary>
    [DataContract]
    [KnownType(typeof(UserInfo))]

    public class GbiUserInfo : UserInfo, IIdentifiable, IUserInfo
    {
        #region Properties

        /// <summary>
        /// Gets or sets the email address.
        /// </summary>
        /// <value>
        /// The email address.
        /// </value>
        [DataMember]
        public string EmailAddress
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the cell phone.
        /// </summary>
        /// <value>
        /// The cell phone.
        /// </value>
        [DataMember]
        public string CellPhone
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the email confirmed stamp.
        /// </summary>
        /// <value>
        /// The email confirmed stamp.
        /// </value>
        [DataMember]
        public DateTime? EmailConfirmedStamp
        {
            get;
            set;
        }

        #endregion

        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="GbiUserInfo"/> class.
        /// </summary>
        public GbiUserInfo()
            : base()
        {
        }

        #endregion
    }
}
