﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using WebChatApi.Common;
using WebChatApi.Common.Interface;

namespace WebChatApi.Model
{
    /// <summary>
    /// Class for base article criteria
    /// </summary>
    [DataContract]
    [KnownType(typeof(BaseCriteria))]
    public class BaseArticleCriteria : BaseCriteria
    {
        /// <summary>
        /// Gets or sets the sorted by.
        /// </summary>
        /// <value>
        /// The sorted by.
        /// </value>
        [DataMember]
        public string SortedBy
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets a value indicating whether this instance is desc.
        /// </summary>
        /// <value>
        ///   <c>true</c> if this instance is desc; otherwise, <c>false</c>.
        /// </value>
        [DataMember]
        public bool IsDesc
        {
            get;
            set;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseArticleCriteria"/> class.
        /// </summary>
        public BaseArticleCriteria()
            : base()
        {
        }

    }
}
