﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common
{
    /// <summary>
    /// Class for email opening track.
    /// </summary>
    [DataContract]
    public class EmailOpeningTrack
    {
        #region Properties

        /// <summary>
        /// Gets or sets the user key.
        /// </summary>
        /// <value>
        /// The user key.
        /// </value>
        [DataMember]
        public Guid UserKey
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the template key.
        /// </summary>
        /// <value>
        /// The template key.
        /// </value>
        [DataMember]
        public Guid TemplateKey
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the template stamp.
        /// </summary>
        /// <value>
        /// The template stamp.
        /// </value>
        [DataMember]
        public string TemplateStamp
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the created stamp.
        /// </summary>
        /// <value>
        /// The created stamp.
        /// </value>
        [DataMember]
        public DateTime CreatedStamp
        {
            get;
            set;
        }

        #endregion

        /// <summary>
        /// Initializes a new instance of the <see cref="EmailOpeningTrack"/> class.
        /// </summary>
        public EmailOpeningTrack()
        {
            this.CreatedStamp = DateTime.UtcNow;
        }
    }
}
