﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common;

namespace WebChatApi.Common.Calendar
{
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public class CalendarMonth
    {
        /// <summary>
        /// The first day of month
        /// </summary>
        protected DateTime firstDayOfMonth;

        #region Properties

        /// <summary>
        /// Gets or sets the date time.
        /// </summary>
        /// <value>
        /// The date time.
        /// </value>
        [DataMember]
        public int Year
        {
            get
            {
                return firstDayOfMonth.Year;
            }
            set
            {
                //Do nothing.
            }
        }

        /// <summary>
        /// Gets or sets a value indicating whether this instance is workday.
        /// </summary>
        /// <value>
        /// <c>true</c> if this instance is workday; otherwise, <c>false</c>.
        /// </value>
        [DataMember]
        public bool IsWorkday
        {
            get;
            set;
        }

        #endregion

        /// <summary>
        /// Initializes a new instance of the <see cref="CalendarMonth"/> class.
        /// </summary>
        public CalendarMonth()
        {
        }

        /// <summary>
        /// To the weeks.
        /// </summary>
        /// <param name="firstDayOfWeek">The first day of week.</param>
        /// <returns></returns>
        public List<CalendarWeek> ToWeeks(DayOfWeek firstDayOfWeek)
        {
            List<CalendarWeek> weeks = new List<CalendarWeek>();
            return weeks;
        }
    }
}
