﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common;

namespace WebChatApi.Common.Calendar
{
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    [KnownType(typeof(BaseObject))]
    public class WorkdayExchange : BaseObject
    {
        #region Properties

        /// <summary>
        /// Gets or sets the date.
        /// </summary>
        /// <value>
        /// The date time.
        /// </value>
        [DataMember]
        public DateTime Date
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets a value indicating whether this instance is workday.
        /// </summary>
        /// <value>
        /// <c>true</c> if this instance is workday; otherwise, <c>false</c>.
        /// </value>
        [DataMember]
        public bool IsWorkday
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the geography tier key.
        /// </summary>
        /// <value>
        /// The geography tier key.
        /// </value>
        [DataMember]
        public Guid? GeographyTierKey
        {
            get;
            set;
        }

        #endregion

        /// <summary>
        /// Initializes a new instance of the <see cref="WorkdayExchange"/> class.
        /// </summary>
        public WorkdayExchange()
            : base()
        {
        }
    }
}
