﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common
{
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public sealed class DynamicPropertyMapping
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DynamicObject"/> class.
        /// </summary>
        public DynamicPropertyMapping()
        {
        }

        #region Properties

        /// <summary>
        /// Gets or sets the name of the source.
        /// </summary>
        /// <value>
        /// The name of the source.
        /// </value>
        [DataMember]
        public string SourceName
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name of the property.
        /// </summary>
        /// <value>
        /// The name of the property.
        /// </value>
        [DataMember]
        public string PropertyName
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the default value.
        /// </summary>
        /// <value>
        /// The default value.
        /// </value>
        [DataMember]
        public string DefaultValue
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the complex object value.
        /// </summary>
        /// <value>
        /// The complex object value.
        /// </value>
        [DataMember]
        public DynamicPropertyMappingCollection ComplexObjectValue
        {
            get;
            set;
        }

        #endregion
    }
}
