﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using WebChatApi.Common;
using WebChatApi.Common.Interface;

namespace WebChatApi.Model
{
    /// <summary>
    /// Class KeyBasedPagingCriteria.
    /// </summary>
    [DataContract]
    public class KeyBasedPagingCriteria : IKeyBasedPagingCriteria
    {
        /// <summary>
        /// Gets or sets the last retrieved key.
        /// </summary>
        /// <value>The last retrieved key.</value>
        [DataMember]
        public Guid? LastRetrievedKey
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the count.
        /// </summary>
        /// <value>The count.</value>
        [DataMember]
        public int Count
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the user key.
        /// </summary>
        /// <value>The user key.</value>
        [DataMember]
        public Guid? UserKey
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets a value indicating whether [order description].
        /// </summary>
        /// <value><c>true</c> if [order description]; otherwise, <c>false</c>.</value>
        [DataMember]
        public bool OrderDesc
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the include deleted.
        /// </summary>
        /// <value>The include deleted.</value>
        [DataMember]
        public bool IncludeDeleted
        {
            get;
            set;
        }
    }
}
