﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common
{
    /// <summary>
    /// Class for key-name item.
    /// </summary>
    [DataContract]
    [KnownType(typeof(BaseObject))]
    public class KeyNameItem : BaseObject
    {
        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>
        /// The name.
        /// </value>
        [DataMember]
        public string Name
        {
            get;
            set;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="KeyNameItem"/> class.
        /// </summary>
        public KeyNameItem()
            : base()
        {
        }
    }
}
