﻿using System.Runtime.Serialization;

namespace WebChatApi.Common
{
    /// <summary>
    /// Class for third party key-name item.
    /// </summary>
    [DataContract]
    [KnownType(typeof(BaseObject))]
    public class ThirdPartyKeyNameItem : BaseObject
    {
        /// <summary>
        /// Gets or sets the third party identity.
        /// </summary>
        /// <value>The third party identity.</value>
        [DataMember]
        public string ThirdPartyIdentity
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        [DataMember]
        public string Name
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the culture info.
        /// e.g.: zh-CN, en-US, pt-PT, etc.
        /// </summary>
        /// <value>The culture info.</value>
        [DataMember]
        public string CultureInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ThirdPartyKeyNameItem" /> class.
        /// </summary>
        public ThirdPartyKeyNameItem()
            : base()
        {
        }
    }
}
