﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using WebChatApi.Common.Interface;

namespace WebChatApi.Common
{
    /// <summary>
    /// Class for third party key-name object.
    /// </summary>
    [DataContract]
    public class ThirdPartyKeyNameObject<IdentityType>
    {
        /// <summary>
        /// Gets or sets the third party identity.
        /// </summary>
        /// <value>
        /// The third party identity.
        /// </value>
        [DataMember]
        public IdentityType ThirdPartyIdentity
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>
        /// The name.
        /// </value>
        [DataMember]
        public string Name
        {
            get;
            set;
        }
    }
}
