﻿using System;
using System.Runtime.Serialization;

namespace WebChatApi.Common
{
    /// <summary>
    /// Class for basic criteria information.
    /// </summary>
    [DataContract]
    [KnownType(typeof(BaseCriteria))]
    public class UserBasedCriteria : BaseCriteria
    {
        #region Properties

        /// <summary>
        /// Gets or sets the user key.
        /// </summary>
        /// <value>The user key.</value>
        [DataMember]
        public Guid UserKey
        {
            get;
            set;
        }

        #endregion

        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="UserBasedCriteria" /> class.
        /// </summary>
        public UserBasedCriteria()
            : base()
        {
            this.Key = Guid.NewGuid();
        }

        #endregion
    }
}
