﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Web;

namespace WebChatApi.Common
{
    /// <summary>
    /// Class for method filtering
    /// </summary>
    public class MethodFiltering
    {
        /// <summary>
        /// Gets or sets the allowed access.
        /// </summary>
        /// <value>
        /// The allowed access, which is the combined value based on <see cref="MethodAccess" /> instance.
        /// </value>
        public int AllowedAccess { get; set; }

        /// <summary>
        /// Gets or sets the included attributes.
        /// If is null, it means no filtering based on attribute.
        /// </summary>
        /// <value>
        /// The included attributes.
        /// </value>
        public Attribute IncludedAttribute { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="MethodFiltering"/> class.
        /// </summary>
        public MethodFiltering()
        {
        }
    }
}
