﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Security.Cryptography;
using System.IO;
using System.Xml.Linq;
using System.Threading;
using System.Runtime.Serialization;

namespace WebChatApi.Common.LightAccessControl
{
    /// <summary>
    /// Class for AccessLicenseWithSettings
    /// </summary>
    public class AccessLicenseWithSettings : AccessLicense
    {
        /// <summary>
        /// Gets or sets the settings.
        /// </summary>
        /// <value>The settings.</value>
        public Dictionary<string, string> Settings
        {
            get;
            set;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AccessLicenseWithSettings"/> class.
        /// </summary>
        public AccessLicenseWithSettings()
            : base()
        {
            this.Settings = new Dictionary<string, string>();
        }
    }
}
