﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Routing;
using WebChatResponseApplication.Properties;

namespace WebChatResponseApplication
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801
    public class MvcApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            WebApiConfig.Register(GlobalConfiguration.Configuration);
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
        }

        /// <summary>
        /// </summary>
        /// <param name="sender">The sender.</param>
        /// <param name="e">The <see cref="EventArgs"/> instance containing the event data.</param>
        protected void Application_BeginRequest(Object sender, EventArgs e)
        {
            if (Settings.Default.TrackingTraffic)
            {
                try
                {
                    HttpApplication app = (HttpApplication)sender;
                    HttpContext context = app.Context;

                    Framework.Instance.Logger.LogMessageWithTimestamp(Framework.GetRequestLog(context.Request));
                    Framework.Instance.Logger.LogEvent(System.Diagnostics.EventLogEntryType.Information,
                        Framework.GetRequestLog(context.Request));
                }
                catch { }
            }
        }
    }
}